/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICECENTRALWIDGET_H
#define ICECENTRALWIDGET_H

#include <QObject>
#include <QResizeEvent>

#include "iceclientsessionobjectuitransport.h"

/**
Central widget, parent to all ICE top level foice.

TODO - should plug-in a shared object pointer to be the container of the central widget
since all central widgets will be a shared object of some sort anyway. Should have accessors for 
shared object ID, etc. This way, we have a direct association between shared object and view, and
thus can readily support multiple windows per session.

	@author R. Michael Sharkey <mike@pikeaero.com>
*/
class ICECentralWidget : public QWidget
{
	Q_OBJECT
	public:
		ICECentralWidget(QWidget *parent = 0);
		virtual ~ICECentralWidget();
		
		virtual void									setSessionObject(ICEClientSessionObjectUiTransport* so);
		inline ICEClientSessionObjectUiTransport*		sessionObject() {return mSessionObject;}
	protected:
		virtual void									destroySessionObject();
		virtual void									resizeEvent(QResizeEvent* e);
		ICEClientSessionObjectUiTransport* 				mSessionObject;
};

#endif
