/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
  *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "icestatus.h"

#include <QPainter>

ICEStatus::ICEStatus ( QWidget *parent )
: QWidget ( parent )
, mStatus ( ConnectNo )
{
	QSize sz ( 32,32 );
	mIconConnectNo = QPixmap ( ":/icons/connect_no.png" );
	mIconConnectCreating = QPixmap ( ":/icons/connect_creating.png" );
	mIconConnectEstablished = QPixmap ( "/icons/connect_established.png" );
	setMaximumSize ( sz );
	setMinimumSize ( sz );
}


ICEStatus::~ICEStatus()
{}


void ICEStatus::paintEvent ( QPaintEvent* e )
{
	QPixmap pixmap;
	QPainter paint ( this );
	switch ( mStatus )
	{
		case ICEStatus::ConnectNo:
			pixmap = mIconConnectNo;
			break;
		case ICEStatus::ConnectCreating:
			pixmap = mIconConnectCreating;
			break;
		case ICEStatus::ConnectEstablished:
			pixmap = mIconConnectEstablished;
			break;
	}
	paint.drawPixmap ( 0,0,pixmap );
	paint.end();
}
