/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICECLIENTSESSIONOBJECTUIELEMENTTRANSPORT_H
#define ICECLIENTSESSIONOBJECTUIELEMENTTRANSPORT_H

#include "icesessionobject.h"
#include "iceclientuielement.h"

#include <QByteArray>
#include <QString>

/**
Base class of all client-side session objects.

	@author R. Michael Sharkey <mike@pikeaero.com>
*/

class ICEClientSessionObjectUiElementTransport : public ICESessionObject
{
	Q_OBJECT
	public:
		ICEClientSessionObjectUiElementTransport(ICESession *session,QByteArray* id=NULL);
		virtual ~ICEClientSessionObjectUiElementTransport();

		virtual ObjectType			type()		{return TypeUiElementTransport;}

		virtual	ICEClientUiElement*	element();
	public slots:
		virtual	void				setElement(ICEClientUiElement* e);
		virtual	void				deleteElement();
	protected:
		ICEClientUiElement*			mElement;
};

#endif
