/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "iceclientsessionobjectuitransport.h"
#include "icecentralwidget.h"
#include "iceclientsession.h"
#include "iceuiloader.h"

#define inherited ICESessionObject

ICEClientSessionObjectUiTransport::ICEClientSessionObjectUiTransport(ICESession *session,QByteArray* id)
 : inherited(session,id)
 , mScript(NULL)
{
}

ICEClientSessionObjectUiTransport::~ICEClientSessionObjectUiTransport()
{
	if ( mScript != NULL )
	{
		delete mScript;
	}
}

QWidget* ICEClientSessionObjectUiTransport::widget()
{
	QWidget* w = ((ICEClientUi*)mScript->ui())->widget();
	return w;
}


void ICEClientSessionObjectUiTransport::setUi(QByteArray ui)
{
	if ( !ui.isEmpty() )
	{
		ICECentralWidget* centralWidget = (ICECentralWidget*)((ICEClientSession*)session())->mainWindow()->centralWidget();
		mScript = new ICEClientScriptThread( this );
		mScript->ui()->load( ui );
		centralWidget->setSessionObject( this );
	}
}

ICEScriptThread* ICEClientSessionObjectUiTransport::setLocation(QString location)
{
	mLocation=location;
	return NULL;
}

