/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICECLIENTSESSIONOBJECTUITRANSPORT_H
#define ICECLIENTSESSIONOBJECTUITRANSPORT_H

#include "icesessionobject.h"
#include "iceclientscriptthread.h"
#include "iceclientui.h"

#include <QByteArray>
#include <QString>

/**
Base class of all client-side session objects.

	@author R. Michael Sharkey <mike@pikeaero.com>
*/

class ICEClientSessionObjectUiTransport : public ICESessionObject
{
	Q_OBJECT
	public:
		ICEClientSessionObjectUiTransport(ICESession *session,QByteArray* id=NULL);
		virtual ~ICEClientSessionObjectUiTransport();
	
		virtual ObjectType			type()		{return TypeUiTransport;}
		virtual QWidget*			widget();
		virtual	QByteArray			ui()		{return QByteArray();}		/** The form XML data */
		virtual QStringList			uiObjects()	{return QStringList();}		/** The XML data associated with form fields */
		virtual	QString				location()	{return mLocation;}			/** item location */
		virtual	ICEScriptThread*	setLocation(QString location);			/** item location */
	
	public slots:
		virtual	void				setUi(QByteArray ui);					/** The form XML data */
		virtual	void				setUiObjects(QStringList uiObjects){}	/** The XML data associated with form fields */
		
	private:
		QString						mLocation;
		ICEClientScriptThread*		mScript;
};

#endif
