/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "iceclientscriptthread.h"
#include "icesessionobject.h"
#include "iceclientui.h"

#define inherited ICEScriptThread

ICEClientScriptThread::ICEClientScriptThread(ICESessionObject* parent)
	: inherited(parent)
{
	mUi = new ICEClientUi( this );
}


ICEClientScriptThread::~ICEClientScriptThread()
{
}


void ICEClientScriptThread::run()
{
	mScriptEngine = new QScriptEngine();
	QScriptValue sUi = engine()->newQObject(mUi);
	engine()->globalObject().setProperty("ui", sUi);
	engine()->globalObject().setProperty("ICE_SESSION_OBJECT_ID", QScriptValue( engine(), QString( sessionObject()->id() ) ) );
	inherited::run();
}
