/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICECLIENTUI_H
#define ICECLIENTUI_H

#include "iceui.h"
#include "iceclientuielement.h"
#include "iceelementtransportmapitem.h"

#include <QObject>
#include <QList>
#include <QWidget>
#include <QList>

class ICESessionObject;
class ICEScriptThread;

/**
Client side ui object.

	@author R. Michael Sharkey <mike@pikeaero.com>
*/
class ICEClientUi : public ICEUi
{
	Q_OBJECT
	public:
		ICEClientUi(ICEScriptThread *parent);
		~ICEClientUi();
		virtual	QWidget*		widget();
	public Q_SLOTS:
		virtual	void			destroyAll();
		virtual	void			load( QString ui );
		virtual	void			load( QByteArray ui );
	protected:
		virtual QByteArray		findSessionObjectId( QObject* o );
		virtual	bool 			eventFilter(QObject *watched, QEvent *event);
		QList<ICEElementTransportMapItem*>	mElementTransportMap;
};

#endif
