/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   mike@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "icecrypt.h"

extern void dump(QByteArray* bytes);

ICECrypt::ICECrypt()
	: QObject(NULL)
		, mInitialized(false)
{
}

ICECrypt::~ICECrypt()
{
}

void ICECrypt::init( QByteArray* in, QByteArray* out )
{
	mKeyIndex=0;
}

void ICECrypt::cipher( bool encrypt, QString key, QByteArray* in, QByteArray* out )
{
    //fprintf( stderr, "%s: key='%s'\n", encrypt?"encrypt":"decrypt", key.toAscii().data() );
    //fprintf( stderr, "%s(I): in size=%d, out size=%d\n", encrypt?"encrypt":"decrypt", in->size(), out->size() );
    //dump( in );
	mEncrypt = encrypt;
	mKey = key;
	init( in, out );
	out->resize( in->size() );
	for( int index = 0; index < in->size(); index++ ) {
		unsigned char ch1 = in->at(index);
		unsigned char ch2 = mKey.toLatin1().data()[mKeyIndex++];
		out->data()[ index ] = (char)(ch1 ^ ch2);
		if ( mKeyIndex >= mKey.size() ) {
			mKeyIndex = 0;
		}
	}
    //fprintf( stderr, "%s(O): in size=%d, out size=%d\n", encrypt?"encrypt":"decrypt", in->size(), out->size() );
   // dump( out );
}

