/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   mike@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the teice of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICECRYPTBF_H
#define ICECRYPTBF_H

#include <icecrypt.h>

/**
	@author R. Michael Sharkey <mike@pikeaero.com>
*/

#include <QObject>
#include <QByteArray>
#include <QString>

#define MAXKEYBYTES 56          /* 448 bits */
#define BLOWFISH_N  16

class ICECryptBF : public ICECrypt
{
	Q_OBJECT

	public:
		ICECryptBF();
		~ICECryptBF();

		virtual void        cipher( bool encrypt, QString key, QByteArray* in, QByteArray* out );

	private:

		quint32 N() {return BLOWFISH_N;}
		quint32 F(quint32 x);
		void init(QByteArray key);
		void encipher(quint32 *xl, quint32 *xr);
		void decipher(quint32 *xl, quint32 *xr);
		quint32 P[BLOWFISH_N + 2];
		quint32 S[4][256];
		quint32 last_xdatal;
		quint32 last_xdatar;
		bool cbc;
};

#endif
