/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "icedatabase.h"
#include "icesql.h"

#include <QtSql>
#include <QVariant>

ICEDatabase::ICEDatabase()
{
}

bool ICEDatabase::login(QString host,QString dbname,QString login,QString passwd)
{
	bool rc;
	mDatabase = QSqlDatabase::addDatabase("QMYSQL");
	mDatabase.setHostName(host);
	mDatabase.setDatabaseName(dbname);
	mDatabase.setUserName(login);
	mDatabase.setPassword(passwd);
	rc = mDatabase.open(login,passwd);
	emit statusMessage( this, ICESession::ReasonDatabase,tr(rc?"database connected":"database connection failed") );
	return rc;
}

bool ICEDatabase::initialize()
{
	bool rc=true;
	QSqlQuery query = ICESql::queryAll( "create" );			
	if ( query.lastError().type() !=  QSqlError::NoError ) {
		emit statusMessage( this, ICESession::ReasonDatabase, "ICEDatabase::initialize: " + query.lastError().text() );
		rc = false;
	}
	if ( rc ) {
		mDatabase.close();
		rc = mDatabase.open();
	}
	return rc;
}


ICEDatabase::~ICEDatabase()
{
	mDatabase.close();
}

