/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   infoe@pikeaero.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICEDATABASE_H
#define ICEDATABASE_H

#include <QObject>

/**
	@author R. Michael Sharkey <mike@pikeaero.com>
*/

#include <QObject>
#include <QString>
#include <QDateTime>
#include <QSqlDatabase>
#include <QSqlError>

#include "icesession.h"

class ICEDatabase : public QObject
{
		Q_OBJECT
	public:
		ICEDatabase();
		~ICEDatabase();

		bool            login ( QString host,QString dbname,QString user,QString passwd );

		QSqlDatabase&   db()
		{
			return mDatabase;
		}

		QSqlError       lastError()
		{
			return mDatabase.lastError();
		}
		
		bool	initialize();

	signals:
		void            statusMessage ( void *session, ICESession::MessageReason, QString msg );

	private:
		QSqlQuery		initialize( QString name );
		QSqlDatabase	mDatabase;
};

#endif
