/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICEELEMENTTRANSPORTMAPITEM_H
#define ICEELEMENTTRANSPORTMAPITEM_H

#include <QObject>
#include <QByteArray>
#include "icesessionobject.h"

/**
Container class for mapping elements to session ojects.

	@author R. Michael Sharkey <mike@pikeaero.com>
*/
class ICEElementTransportMapItem : public QObject
{
	Q_OBJECT
	public:
		ICEElementTransportMapItem(QObject *parent = 0);
		~ICEElementTransportMapItem();
		virtual QObject* object() {return mObject;}
		virtual QByteArray sessionObjectId() {return mSessionObjectId;}
	public slots:
		virtual void setObject( QObject* o ) {mObject=o;}
		virtual void setSessionObjectId( QByteArray id ) {mSessionObjectId=id;}
	private:
		QByteArray		mSessionObjectId;
		QObject*		mObject;
	
};

#endif
