/***************************************************************************
 *   Copyright (C) 2007 by R. Michael Sharkey   *
 *   mike@pikeaero.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "icelog.h"

bool ICELog::mDebug=false;

ICELog::ICELog()
: QObject()
{}


ICELog::~ICELog()
{}


void ICELog::log ( void* _objaddress, unsigned int _user, int _reason, QString comment )
{
	QDateTime dateTime ( QDate::currentDate(), QTime::currentTime() );
	QString timestamp =   dateTime.toString ( "yyyyMMddhhmmss" );
	QString objaddress =  QString::number ( ( ulong ) _objaddress );
	QString user  =       QString::number ( _user );
	QString reason =      QString::number ( _reason );
	QSqlQuery query ( QString ( "INSERT INTO rmslog ( rmslog.timestamp, rmslog.user, rmslog.objaddress, rmslog.reason, rmslog.comment) " +
	                            QString ( "VALUES ( '"+timestamp+"','"+user+"','"+objaddress+"','"+reason+"','"+comment+"' )" ) ) );
	if ( !query.lastError().type() == QSqlError::NoError )
	{
		fprintf ( stderr, "[%p]: sql error: %s\n", this, query.lastError().driverText().toAscii().data() );
	}
	if ( debugEnabled() )
	{
		fprintf ( stderr, "%s\n", QString ( timestamp+":"+user+":"+objaddress+":"+reason+":"+comment ).toAscii().data() );
	}
}

