/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "icerecord.h"

ICERecord::ICERecord ( QObject *parent )
		: QObject ( parent )
{
	QObject::connect ( this,
	                   SIGNAL ( signalError ( void*,unsigned int, int, QString ) ),
	                   this,
	                   SLOT ( slotError ( void*,unsigned int, int, QString ) ) );
}


ICERecord::~ICERecord()
{}


void ICERecord::slotError ( void* _objaddress, unsigned int user, int _reason, QString comment )
{
	if ( m_log == NULL )
	{
		ICELog log;
		log.log ( _objaddress, getUser ( user ), _reason, comment );
	}
	else
	{
		m_log->log ( _objaddress, getUser ( user ),  _reason, comment );
	}
}
