/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICERECORD_H
#define ICERECORD_H

#include <QObject>

/**
	@author R. Michael Sharkey <mike@pikeaero.com>
*/

#include <QObject>

#include "icelog.h"

class ICERecord : public QObject
{
		Q_OBJECT
	public:
		ICERecord ( QObject *parent = 0 );
		~ICERecord();

		void setLog ( ICELog* log ) {m_log=log;}
		ICELog* getLog() {return m_log;}
		void setUser ( unsigned int user ) {m_user=user;}
		unsigned int getUser() {return m_user;}
		unsigned int getUser ( unsigned int user ) {if ( m_user ) return m_user; else return user;}

	signals:
		void signalError ( void* _objaddress, unsigned int _user, int _reason, QString comment );

	protected slots:
		void slotError ( void* _objaddress, unsigned int _user,  int _reason, QString comment );

	private:
		ICELog* m_log;
		unsigned int m_user;

};
#endif
