/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Rsearch Corporation              *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICESERVER_H
#define ICESERVER_H

#include <QtCore>
#include <QObject>
#include <QString>
#include <QAbstractSocket>
#include <QList>
#include <QSettings>

#include "iceserverversion.h"
#include "icesocket.h"
#include "iceserversession.h"
#include "iceservertcp.h"
#include "icedatabase.h"
#include "icesql.h"


class ICEServer : public QObject
{
		Q_OBJECT
	public:
		ICEServer ( QObject *parent=0 );
		~ICEServer();
		static QString trademark() {return QString("ICE Server") + '®';}
		static QString copyright() {return QString( QString("Copyright") + '©' ) + "2007 Pike Aerospace Research Corp.";}
		static QString version()   {return "0.3.5";}
		static unsigned int    sessionCount() {return mSessionList.count();}
	signals:
		void			statusMessage ( void *session, ICESession::MessageReason, QString msg );
		void            quit();
	public slots:
		void			readSettings();
		void			writeSettings();
		void			slotStatusMessage ( void* session, ICESession::MessageReason, QString msg );
	protected slots:
		void            newConnection();
	protected:
		void            timerEvent ( QTimerEvent* event );
	private slots:
		void            initialize();
		void            sessionClosed();
	private:
		void                    spawnNewSession ( QTcpSocket* socket );
		ICEServerTcp            mServerTcp;
		ICEDatabase             mDatabase; 
		int                     mSlowTimer;
		int                     mFastTimer;
		static QList<ICEServerSession*> mSessionList;
		bool                    mInitialized;
		ICESql					mSQL;
};

#endif
