/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "iceserverstatistics.h"

QMutex ICEServerStatistics::mTXPacketsMutex;
quint64 ICEServerStatistics::mTXPackets=0L;

QMutex ICEServerStatistics::mRXPacketsMutex;
quint64	ICEServerStatistics::mRXPackets=0L;

QDateTime ICEServerStatistics::mStartDateTime=QDateTime::currentDateTime();

ICEServerStatistics::ICEServerStatistics(QObject *parent)
 : QObject(parent)
{
}


ICEServerStatistics::~ICEServerStatistics()
{
}

void ICEServerStatistics::incrementTXPackets() 
{
	mTXPacketsMutex.lock(); 
	mTXPackets += 1;
	mTXPacketsMutex.unlock();
}

void ICEServerStatistics::incrementRXPackets() 
{
	mRXPacketsMutex.lock();
	mRXPackets += 1;
	mRXPacketsMutex.unlock();
}

void ICEServerStatistics::setTXPackets(quint64 txb) 
{
	mTXPacketsMutex.lock(); 
	mTXPackets=txb;
	mTXPacketsMutex.unlock();
}

void ICEServerStatistics::setRXPackets(quint64 rxb) 
{
	mRXPacketsMutex.lock();
	mRXPackets=rxb;
	mRXPacketsMutex.unlock();
}

quint64 ICEServerStatistics::getTXPackets() 
{
	return mTXPackets;
}

quint64 ICEServerStatistics::getRXPackets() 
{
	return mRXPackets;
}
	

