/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICESERVERSESSIONOBJECTUITRANSPORT_H
#define ICESERVERSESSIONOBJECTUITRANSPORT_H

#include "icesessionobject.h"
#include "iceserversession.h"

#include <QTimerEvent>
#include <QByteArray>

/**
A server item

	@author R. Michael Sharkey <mike@pikeaero.com>
*/
class ICEServerSessionObjectUiTransport : public ICESessionObject
{
	Q_OBJECT
	public:
		ICEServerSessionObjectUiTransport(ICEServerSession *session,QByteArray* id);
		~ICEServerSessionObjectUiTransport();
		
		virtual ObjectType				type() 		{return TypeUiTransport;}
		virtual	QByteArray				ui()		{return mUi;}				/** The form XML data */
		virtual QStringList				uiObjects()	{return QStringList();}		/** The object path list */
		virtual	QString					location();								/** item location */
		virtual	ICEScriptThread*		setLocation(QString location);			/** item location */
		
	public slots:
		virtual	void					setUi(QByteArray ui);					/** The form XML data */
		virtual	void					setUiObjects(QStringList uiObjects) {}	/** The XML data associated with form fields */
		
	private:
		QString		mLocation;
		QByteArray	mUi;
};


#endif
