/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "iceserverui.h"
#include "iceserversettings.h"
#include "iceuireader.h"

extern ICEServerSettings serverSettings; /** FIXME - should be a static member of ICEServer */


#define inherited ICEUi

ICEServerUi::ICEServerUi(ICEScriptThread *parent)
 : inherited(parent)
{
}


ICEServerUi::~ICEServerUi()
{
}

void ICEServerUi::load( QString ui )
{
	bool rc=false;
	QString error;
	QString root = serverSettings.getDataRoot().trimmed();
	if ( root.right(1) != "/" )
	{
		root += "/";
	}
	ui = root + ui.trimmed();
	inherited::load( ui );
}

void ICEServerUi::load( QByteArray ui )
{
	inherited::load( ui );
	ICEUiReader uiReader( ui );
	uiReader.read();
}

