/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "iceuielement.h"
#include "icesessionobject.h"
#include "icesession.h"
#include "iceui.h"

#define inherited QObject

ICEUiElement::ICEUiElement(ICEUi* ui, QObject *parent)
 : inherited(parent)
 , mUi(ui)
 , mSessionObject(NULL)
{
}


ICEUiElement::~ICEUiElement()
{
}

/**
** \brief - access to the Ui object.
*/
ICEUi* ICEUiElement::ui()
{
	return mUi;
}

/**
** \brief - access to the session.
*/
ICESession* ICEUiElement::session()
{
	return ui()->session();
}

/**
** \brief - access to the session object
*/
ICESessionObject* ICEUiElement::sessionObject()	
{
	return ui()->sessionObject();
}


