/***************************************************************************
 *   Copyright (C) 2007 by Pike Aerospace Research Corporation             *
 *   info@pikeaero.com                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ICEUIELEMENT_H
#define ICEUIELEMENT_H

#include <QObject>

class ICESession;
class ICESessionObject;
class ICEUi;

/**
Base class for shared UI objects
	@author R. Michael Sharkey <mike@pikeaero.com>
*/
class ICEUiElement : public QObject
{
	Q_OBJECT
	public:
		ICEUiElement(ICEUi* ui=0, QObject *parent = 0);
		~ICEUiElement();
		ICEUi*				ui();
		ICESession*			session();
		ICESessionObject*	sessionObject();
	private:
		ICESessionObject*	mSessionObject;
		ICEUi*				mUi;
};

#endif
